include "console.iol"
include "time.iol"
include "string_utils.iol"
include "json_utils.iol"
include "math.iol"

inputPort IN {
  Location: "socket://localhost:8001"
  Protocol: http
  RequestResponse: hasNextStop, calculateDelay
}

execution{ sequential }

main
{
  [ hasNextStop( req )( hasNext ){
    getJsonValue@JsonUtils( req.p )( req );
    print@Console( "Checking whether line " + req.line + " has next stop: " )();
    if ( is_defined( req.shd[ global.lines.( req.line ).i ] ) ){
      println@Console( "true, waiting " + req.shd[ global.lines.( req.line ).i ] + " seconds" )();
      sleep@Time( req.shd[ global.lines.( req.line ).i++ ] )();
      hasNext = true
    } else {
      println@Console( "false" )();
      hasNext = false;
      global.lines.( req.line ) = 0
      // undef( global.( req.line ) ) // MORE IN GENERAL, global.( req.line )
    }
  } ]
  [ calculateDelay( req )( delay ){
    getJsonValue@JsonUtils( req.p )( req );
    random@Math()( delay );
    delay = delay * 10000.0;
    println@Console( "calculated delay for " + req.line + " as " + delay )()
  } ]
}