execution { concurrent }

type OpType:void {
  .msgID:string
  .content?:undefined
}

type CoordType:void {
  .rolesNum:int
  .hasAck?:bool
  .sid:string
}

type JoinType:void {
  .sid:string
}

interface MHInterface {
OneWay:
  initStartProcedure( CoordType )
RequestResponse:
  passPosition( OpType )( undefined ), passSchedule( OpType )( undefined ), joinAck( JoinType )( void ), get_passPosition( OpType )( undefined ), joinStart( JoinType )( void ), get_op0( OpType )( undefined ), get_passSchedule( OpType )( undefined ), op0( OpType )( undefined )
}

inputPort MyInputPort {
Location: "local"
Interfaces: MHInterface
}

cset { 
msgID:
  OpType.msgID
}

cset { 
sid:
  CoordType.sid JoinType.sid
}

define joinStart
{
  joinStart(  )( 	 ) {
    if (     --joinStartCounter > 0 ) {
      joinStart
    }	
  }
}

define joinAck
{
  joinAck(  )( 	 ) {
    if (     --joinAckCounter > 0 ) {
      joinAck
    }	
  }
}

main
{
  [ initStartProcedure( startRequest ) ] {
    joinStartCounter =     joinAckCounter = startRequest.rolesNum;
    joinStart;
    if ( startRequest.hasAck ) {
      joinAck
    }
  }
  [ passPosition( c )(  ) {
  get_passPosition(  )( c	 ) {
    nullProcess	
  }
} ] {
    nullProcess
  }
  [ get_passPosition( c )( c1 ) {
  passPosition( c1 )( 	 ) {
    nullProcess	
  }
} ] {
    nullProcess
  }
  [ passSchedule( c )(  ) {
  get_passSchedule(  )( c	 ) {
    nullProcess	
  }
} ] {
    nullProcess
  }
  [ get_passSchedule( c )( c1 ) {
  passSchedule( c1 )( 	 ) {
    nullProcess	
  }
} ] {
    nullProcess
  }
  [ op0( c )(  ) {
  get_op0(  )( c	 ) {
    nullProcess	
  }
} ] {
    nullProcess
  }
  [ get_op0( c )( c1 ) {
  op0( c1 )( 	 ) {
    nullProcess	
  }
} ] {
    nullProcess
  }
}

